public class ExceptionTest {

    static int factorial( int n ) throws LessThanOneException
    {
        if( n < 1 )
            throw new LessThanOneException( "less than one exception here" );

        int fact = 1;
        for( int i = 1; i <= n; ++i )
            fact *= i;
        return fact;
    }

    /*
     * if we don't want to handle an exception, simply declare it in the method
     * header.
     */
    /*
    public static void main( String args[] ) throws LessThanOneException
    {
        int f = factorial( -10 );
        System.out.println( f );
    }
    */

    /*
     * if we want to handle an exception, enclose the regular code in a try
     * block, and enclose the error handling code in a catch block.
     */
    public static void main( String args[] )
    {
        int f = 0;

        try
        {
            f = factorial( -10 );
        }
        catch( LessThanOneException e )
        {

            System.err.println( e.getMessage() );
            e.printStackTrace();
            f = 0;
        }

        System.out.println( f );
    }

}
